<script lang="ts" setup>
import { useReportStore } from '@/stores/report';
import { onMounted, onUnmounted, ref } from 'vue';
import Chart from 'chart.js/auto';
const reportStore = useReportStore();
const chartRefBar = ref();
const chartRefNut = ref();
const chartRefLine = ref();
const chart = ref(0);
const table = ref(0);
// const chartOptions = {
//   scales: {
//     y: {
//       beginAtZero: true
//     }
//   }
// };
// let chartData = {
//   labels: reportStore.price7day,
//   datasets: [
//     {
//       label: 'รายรับ 7 วัน',
//       data: reportStore.price7sum,
//       fill: false,
//       borderWidth: 1,
//       tension: 0.1
//     }
//   ]
// };
// const createChart = () => {
//   const ctx = chartRef.value?.getContext('2d')!;
//   return new Chart(ctx, {
//     type: 'line',
//     data: chartData,
//     options: chartOptions,
//   });
// };

// css chart
const chartOptions = {
    scales: {
        y: {
            beginAtZero: true,
            ticks: {
                font: {
                    family: 'Noto Sans Thai',
                    size: 12,
                    weight: 'bold'
                }
            }
        },
        x: {
            ticks: {
                font: {
                    family: 'Noto Sans Thai',
                    size: 12,
                    weight: 'bold'
                }
            }
        },
    },
    plugins: {
        title: {
            display: true,
            font: {
                family: 'Noto Sans Thai',
                weight: 'bold',
                size: 20
            }
        },
        legend: {
            labels: {
                font: {
                    family: 'Noto Sans Thai',
                    weight: 'bold',
                    size: 16
                }
            }
        },
    }
};

const createChartBar = () => {
    const ctx = chartRefBar.value?.getContext('2d')!;
    return new Chart(ctx, {
        type: 'bar',
        data: {
            labels: reportStore.price7day,
            // labels: ['Sunday', 'Monday', 'Tuesday', 'Wednesday', 'Thursday', 'Friday', 'Saturday'],
            datasets: [{
                label: 'รายรับ 7 วัน',
                data: reportStore.price7sum,
                // backgroundColor: '#FD625E', 
                backgroundColor: '#01B8AA',
                // fill: false,
                borderWidth: 1,
                // tension: 0.1
            },
            ]
        },
        options: chartOptions,
    });
};


const createChartNut = () => {
    const ctx = chartRefNut.value?.getContext('2d')!;
    return new Chart(ctx, {
        type: 'doughnut',
        data: {
            labels: reportStore.price7day,
            // labels: ['Sunday', 'Monday', 'Tuesday', 'Wednesday', 'Thursday', 'Friday', 'Saturday'],
            datasets: [{
                label: 'รายรับ 7 วัน',
                data: reportStore.price7sum,
                backgroundColor: [
                    '#FC2D1E',
                    '#F1C40F',
                    '#EF7C91',
                    '#2DCC70',
                    '#E67F22',
                    '#5CACE1',
                    '#9A59B5'],
                // fill: false,
                borderWidth: 1,
                // tension: 0.1
            },
            ]
        },
        options: chartOptions,
    });
};

const createChartLine = () => {
    const ctx = chartRefLine.value?.getContext('2d')!;
    return new Chart(ctx, {
        type: 'line',
        data: {
            labels: reportStore.price7day,
            // labels: ['Sunday', 'Monday', 'Tuesday', 'Wednesday', 'Thursday', 'Friday', 'Saturday'],
            datasets: [{
                label: 'รายรับ 7 วัน',
                data: reportStore.price7sum,
                backgroundColor: [
                    '#FC2D1E',
                    '#F1C40F',
                    '#EF7C91',
                    '#2DCC70',
                    '#E67F22',
                    '#5CACE1',
                    '#9A59B5'],
                // fill: false,
                borderWidth: 1,
                // tension: 0.1
            },
            ]
        },
        options: chartOptions,
    });
};


function getItem() {
    reportStore.getSumPrice(reportStore.time);
    reportStore.getSumOrder(reportStore.time);
    reportStore.getCountTable(reportStore.time);
    reportStore.getTopMenu(reportStore.time);
    reportStore.getTopChef(reportStore.time);
    reportStore.getTopServe(reportStore.time);
    reportStore.getprice().then(() => {
        createChartBar();
        createChartNut();
        createChartLine();
    });
}

onMounted(async () => {
    await getItem();
});

setInterval(getItem, 1000);
</script>

<template>
    <v-container>
        <v-row class="justify-center">
            <v-card class="pa-5 ma-2 text-h4 text-center" width="100%" color="#1C6758" style="color: white"><label
                    style="padding: 10px; font-size: 48px ">แดชบอร์ด</label>
            </v-card>
        </v-row>
        <div style="padding: 5px"></div>
        <div style="text-align: end;">
            <v-btn class="date" variant="text" @click="reportStore.time = 'day',reportStore.reset()"
                :color="reportStore.time === 'day' ? 'red' : 'grey'">
                วันนี้
            </v-btn>/
            <v-btn class="date" variant="text" @click="reportStore.time = 'month',reportStore.reset()"
                :color="reportStore.time === 'month' ? 'red' : 'grey'">
                เดือนนี้
            </v-btn>/
            <v-btn class="date" variant="text" @click="reportStore.time = 'year',reportStore.reset()"
                :color="reportStore.time === 'year' ? 'red' : 'grey'">
                ปีนี้
            </v-btn>/
            <v-btn class="date" variant="text" @click="reportStore.time = ''"
                :color="reportStore.time === '' ? 'red' : 'grey'">
                ทั้งหมด
            </v-btn>
        </div>
        <div style="padding: 3px"></div>
        <v-row>
            <v-col cols="12" sm="6" md="4">
                <v-card color="#FFEFCF" style="color: white">
                    <div class="d-flex align-center">
                        <v-avatar size="125" rounded="0" color="#2a9d8f">
                            <v-icon color="white" size="80px">mdi-cash-multiple</v-icon>
                        </v-avatar>
                        <div class="text-center align-center" style="width: 100%;">
                            <v-card-title class="text-h5"><label style="color: black;">{{ reportStore.sumprice }}
                                    ฿</label></v-card-title>
                            <v-card-subtitle><label
                                    style="font-size: 16px; color: black;">จำนวนรายรับทั้งหมด</label></v-card-subtitle>
                        </div>
                    </div>
                </v-card>
            </v-col>

            <v-col cols="12" sm="6" md="4">
                <v-card color="#FFEFCF" style="color: white">
                    <div class="d-flex align-center">
                        <v-avatar size="125" rounded="0" color="#e76f51">
                            <v-icon color="white" size="80px">mdi-food</v-icon>
                        </v-avatar>
                        <div class="text-center align-center" style="width: 100%;">
                            <v-card-title class="text-h5"><label style="color: black;">{{ reportStore.sumOrder }}
                                    จาน</label></v-card-title>
                            <v-card-subtitle><label
                                    style="font-size: 16px; color: black;">จำนวนอาหาร</label></v-card-subtitle>
                        </div>
                    </div>
                </v-card>
            </v-col>

            <v-col cols="12" sm="6" md="4">
                <v-card color="#FFEFCF" style="color: white">
                    <div class="d-flex align-center">
                        <v-avatar size="125" rounded="0" color="#e9c46a">
                            <v-icon color="white" size="80px">mdi-table-furniture</v-icon>
                        </v-avatar>
                        <div class="text-center align-center" style="width: 100%;">
                            <v-card-title class="text-h5 "><label style="color: black;">{{ reportStore.countTable }}
                                    ครั้ง</label></v-card-title>
                            <v-card-subtitle><label
                                    style="font-size: 16px; color: black;">จำนวนโต๊ะที่เปิด</label></v-card-subtitle>
                        </div>
                    </div>
                </v-card>
            </v-col>
        </v-row>
        <v-row>
            <v-col cols="8">
                <div style="text-align: end; padding-top: 10px;">
                    <v-btn class="date" variant="text" @click="chart = 0" :color="chart === 0 ? 'red' : 'grey'">Bar
                    </v-btn>/
                    <v-btn class="date" variant="text" @click="chart = 1" :color="chart === 1 ? 'red' : 'grey'">Doughnut
                    </v-btn>/
                    <v-btn class="date" variant="text" @click="chart = 2" :color="chart === 2 ? 'red' : 'grey'">Line
                    </v-btn>
                </div>
                <div v-if="chart == 0" class="chart-div">
                    <canvas ref="chartRefBar"></canvas>
                </div>
                <div v-if="chart == 1" class="chart-div">
                    <canvas ref="chartRefNut"></canvas>
                </div>
                <div v-if="chart == 2" class="chart-div">
                    <canvas ref="chartRefLine"></canvas>
                </div>
            </v-col>
            <v-col cols="4">
                <div style="text-align: end; padding-top: 10px;">
                    <v-btn class="date" variant="text" @click="table = 0" :color="table === 0 ? 'red' : 'grey'">เมนูอาหารที่ขายดี
                    </v-btn>/
                    <v-btn class="date" variant="text" @click="table = 1" :color="table === 1 ? 'red' : 'grey'">พ่อครัวมือไว
                    </v-btn>/
                    <v-btn class="date" variant="text" @click="table = 2" :color="table === 2 ? 'red' : 'grey'">เด็กเสิร์ฟตีนผี
                    </v-btn>
                </div>
                <div v-if="table == 0">
                    <v-card class="pa-5 ma-2 text-center" width="100%" color="#1C6758" style="color: white">
                    <v-card-title class="text-h5 align-center text-center justify-center"><label
                            style="font-size:40px">เมนูอาหารที่ขายดี</label></v-card-title>
                    <div style="padding: 5px"></div>
                    <v-table id="table" style="width: 100%;max-height: 400px; overflow-y: auto;">
                        <thead>
                            <tr>
                                <th>อันดับที่</th>
                                <th>ชื่อเมนูอาหาร</th>
                                <th>จำนวนครั้ง</th>
                            </tr>
                        </thead>
                        <tbody>
                            <tr v-for="item of reportStore.topMenu" v-bind:key="item.id">
                                <td>{{ item.id }}</td>
                                <td>{{ item.name }}</td>
                                <td>{{ item.sum }}</td>
                            </tr>
                        </tbody>
                    </v-table>
                </v-card>
                </div>
                <div v-if="table == 1">
                    <v-card class="pa-5 ma-2 text-center" width="100%" color="#1C6758" style="color: white">
                    <v-card-title class="text-h5 align-center text-center justify-center"><label
                            style="font-size:40px">พ่อครัวมือไว</label></v-card-title>
                    <div style="padding: 5px"></div>
                    <v-table id="table" style="width: 100%; max-height: 400px; overflow-y: auto;">
                        <thead>
                            <tr>
                                <th>อันดับที่</th>
                                <th>ชื่อ</th>
                                <th>จำนวน/จาน</th>
                            </tr>
                        </thead>
                        <tbody>
                            <tr v-for="item of reportStore.topChef" v-bind:key="item.id">
                                <td>{{ item.id }}</td>
                                <td>{{ item.fname }} {{ item.lname }}</td>
                                <td>{{ item.count }}</td>
                            </tr>
                        </tbody>
                    </v-table>
                </v-card>
                </div >
                <div v-if="table == 2">
                    <v-card class="pa-5 ma-2 text-center" width="100%" color="#1C6758" style="color: white">
                    <v-card-title class="text-h5 align-center text-center justify-center"><label
                            style="font-size:40px">เด็กเสิร์ฟตีนผี</label></v-card-title>
                    <div style="padding: 5px"></div>
                    <v-table id="table" style="width: 100%; max-height: 400px; overflow-y: auto;">
                        <thead>
                            <tr>
                                <th>อันดับที่</th>
                                <th>ชื่อ</th>
                                <th>จำนวน/ชิ้น</th>
                            </tr>
                        </thead>
                        <tbody>
                            <tr v-for="item of reportStore.topServe" v-bind:key="item.id">
                                <td>{{ item.id }}</td>
                                <td>{{ item.fname }} {{ item.lname }}</td>
                                <td>{{ item.count }}</td>
                            </tr>
                        </tbody>
                    </v-table>
                </v-card>
                </div>
            </v-col>
        </v-row>
        <!-- <v-row>
            <v-col cols="12" sm="6" md="4">
                <v-card class="pa-5 ma-2 text-center" width="100%" color="#1C6758" style="color: white">
                    <v-card-title class="text-h5 align-center text-center justify-center"><label
                            style="font-size:40px">เมนูอาหารที่ขายดี</label></v-card-title>
                    <div style="padding: 5px"></div>
                    <v-table id="table" style="width: 100%;max-height: 450px; overflow-y: auto;">
                        <thead>
                            <tr>
                                <th>อันดับที่</th>
                                <th>ชื่อเมนูอาหาร</th>
                                <th>จำนวนครั้ง</th>
                            </tr>
                        </thead>
                        <tbody>
                            <tr v-for="item of reportStore.topMenu" v-bind:key="item.id">
                                <td>{{ item.id }}</td>
                                <td>{{ item.name }}</td>
                                <td>{{ item.sum }}</td>
                            </tr>
                        </tbody>
                    </v-table>
                </v-card>
            </v-col>

            <v-col cols="12" sm="6" md="4">
                <v-card class="pa-5 ma-2 text-center" width="100%" color="#1C6758" style="color: white">
                    <v-card-title class="text-h5 align-center text-center justify-center"><label
                            style="font-size:40px">พ่อครัวมือไว</label></v-card-title>
                    <div style="padding: 5px"></div>
                    <v-table id="table" style="width: 100%; max-height: 450px; overflow-y: auto;">
                        <thead>
                            <tr>
                                <th>อันดับที่</th>
                                <th>ชื่อ</th>
                                <th>จำนวน/จาน</th>
                            </tr>
                        </thead>
                        <tbody>
                            <tr v-for="item of reportStore.topChef" v-bind:key="item.id">
                                <td>{{ item.id }}</td>
                                <td>{{ item.fname }} {{ item.lname }}</td>
                                <td>{{ item.count }}</td>
                            </tr>
                        </tbody>
                    </v-table>
                </v-card>
            </v-col>

            <v-col cols="12" sm="6" md="4">
                <v-card class="pa-5 ma-2 text-center" width="100%" color="#1C6758" style="color: white">
                    <v-card-title class="text-h5 align-center text-center justify-center"><label
                            style="font-size:40px">เด็กเสิร์ฟตีนผี</label></v-card-title>
                    <div style="padding: 5px"></div>
                    <v-table id="table" style="width: 100%; max-height: 450px; overflow-y: auto;">
                        <thead>
                            <tr>
                                <th>อันดับที่</th>
                                <th>ชื่อ</th>
                                <th>จำนวน/ชิ้น</th>
                            </tr>
                        </thead>
                        <tbody>
                            <tr v-for="item of reportStore.topServe" v-bind:key="item.id">
                                <td>{{ item.id }}</td>
                                <td>{{ item.fname }} {{ item.lname }}</td>
                                <td>{{ item.count }}</td>
                            </tr>
                        </tbody>
                    </v-table>
                </v-card>
            </v-col>

        </v-row> -->
    </v-container>
</template>

<style scoped>
@import url("https://fonts.googleapis.com/css2?family=Noto+Sans+Thai:wght@100&display=swap");


.date {
    font-family: "Noto Sans Thai", sans-serif;
    font-weight: bold !important;
}

label {
    font-family: "Noto Sans Thai", sans-serif;
    font-weight: bold;
    /* font-size: 48px !important; */
}

th {
    font-family: "Noto Sans Thai", sans-serif;
    font-size: 18px !important;
    text-align: center;
    font-weight: bold !important;
}

td {
    font-family: "Noto Sans Thai", sans-serif;
    font-size: 14px !important;
    font-weight: bold;
    text-align: center;
}

#table {
    border-collapse: collapse;
    width: 100%;
}

#table td,
#table th {
    padding: 10px;
    text-align: center;
}

#table th {
    padding-top: 12px;
    padding-bottom: 12px;
    text-align: center;
    font-weight: bold;
    background-color: #fd722c;
    color: black;

}

#table tr {
    padding-top: 12px;
    padding-bottom: 12px;
    text-align: left;
    background-color: #FFEFCF;
    color: black;
}

.chart-div {
    width: 100%;
    height: 500px;
}

canvas {
    margin: auto;
    width: 100%;
    height: 100%;
}</style>